=== debian/changelog ===
oxide-qt (1.21.5-0ubuntu1) zesty; urgency=medium

  * Update to v1.21.5 (see USN-3236-1)
    - Bump Chromium rev to 57.0.2987.110
    - Build everything with the correct symbol visibility (-fvisibility=hidden)
    - Revert "Decide focus state of webview based on activeFocusItem check of
      window", as it caused a regression in popup menu handling (LP: #1649577)
    - Unbreak build for older CMake versions
    - Unbreak ENABLE_PLUGINS=0 build
    - Fix LP: #1654363 - Fails to build with vivid gcc
    - Fix LP: #1654512 - Unbreak component build
    - Fix LP: #1649577 - Decide the webview focus state from ItemChanged event
      not the focusIn/Out events
    - Fix LP: #1637194 - Add <select> popup menu implementation to UbuntuWebView
    - Fix LP: #1656303 - Test hang at the start of tst_focus.qml
    - Fix LP: #1649861 - Session save/restore across oxide versions
    - Test that we don't leak context menus or popup menus when a webview
      closes
    - tst_WebViewPopupMenu.qml should verify that the menu is visible
    - Fix CMake error on cross-compilation after installing qtsystems5-dev
    - Make WebContextMenu and WebPopupMenu ownership more obvious
    - Fix LP: #1647799 - Don't run ubuntu-api and ubuntu-ui test sequences
      when built without ENABLE_UITK_WEBVIEW
    - Fix LP: #1568296, LP: #1656905 - Change the behaviour of JS dialogs.
      + Alert dialogs requested from background webviews are no longer
        displayed immediately, but are delayed until the webview is brought to
        the foreground. In this case, window.alert() returns and script
        execution continues immediately.
      + Confirm and prompt dialogs from background webviews are suppressed.
      + Dialogs are automatically dismissed if another webview is brought to
        the foreground.
      + Before Unload dialogs will only be displayed if they are associated
        with a navigation that is application initiated or triggered from a
        user gesture. Otherwise, the navigation will proceed without a prompt.
    - Remove the openerName parameter from WebContextMenuDesktop.qml
    - Fix a case where the JavaScriptDialog implementation could leak
    - Fix LP: #1637195 - Add JS dialog implementation to UbuntuWebView
    - Emit warnings when trying to provide dialog components with UbuntuWebView
    - Use AuxiliaryUIFactory for legacy UI components, and add a "Legacy"
      prefix to those classes
    - Rename qt::Web{Context,Popup}MenuImpl to qt::Web{Context,Popup}MenuHost
      for consistency with JavaScriptDialogHost
    - Fix LP: #1665978 - Sync ParamTraits for content::WebPreferences to make
      double-tap-to-zoom work again
    - Fix LP: #1668614 - Fix build failure with GCC 4.8 due to lack of
      stdatomic.h

  * Refresh gross-hack-for-dual-ffmpeg-build.patch
  * Drop debian/patches/lp1642317.patch - fixed upstream

 -- Chris Coulson <chris.coulson@canonical.com>  Fri, 17 Mar 2017 21:30:31 +0000

oxide-qt (1.20.4-0ubuntu1) zesty; urgency=medium

  * Update to v1.20.4 (see USN-3180-1)
    - Bump Chromium rev to 56.0.2924.87
    - Fix LP: #1642318 - Build failure on arm64
    - Fix LP: #1649861 - session save/restore across oxide versions
    - Fix LP: #1632490 - Disable zoom-for-dsf
    - Fix LP: #1632487 - Update tst_WebView_findController.qml to test that
      results are updated on navigation
    - Fix LP: #1610929 - Implement Screen::GetShellMode()
    - Fix LP: #1637184 - Add libOxideUbuntuUITK, associated QML plugin and
      UbuntuWebView implementation, which will eventually replace the
      Ubuntu.Web component
    - Stop using Q_DECL_EXPORT in various places
    - Enable use_external_popup_menu and remove our hack for supporting these
    - Refactor WebContextMenu
    - Documentation changes - ensure that the PermissionRequest classe
      indicate the inheritance chain and add missing entries for a few signals
    - Remove WebView::GetDisplay, as it's unused
    - Pass context menu params to the webview via a separate object
    - Fix a compiler warning
    - Fix a build failure with ENABLE_HYBRIS_CAMERA
    - Fix a build failure with ENABLE_COMPONENT_BUILD
    - Fix media hub build
    - Fix LP: #1637186 - Add context menu implementation to UbuntuWebView
    - Disable enable_media_routing as it results in a lot of console spam now
    - Fix LP: #1639241 - Set the solid colour scrollbar colour correctly
    - Fix LP: #1643428 - Fix an issue where the fling direction sometimes
      reverses
    - Fix a build failure with ENABLE_HYBRIS_CAMERA
    - Fix LP: #1643548 - Emit a warning when importing Oxide.Ubuntu
    - Fix LP: #1642381 - Don't spin up a zygote process in single process mode
    - Remove OXIDE_DISABLE_SETUID_SANDBOX environment variable - it doesn't
      work anyway
    - Ensure that the value returned from TestApi.getBoundingClientRectForSelector
      is scaled correctly
    - Fix LP: #1637187 - Add QML tests for context menu
    - Fix LP: #1637190 - Add API to allow embedders to customize actions in
      the context menu
    - Fix LP: #1640634 - "Open {link,media} in new {tab,window}" entries in
      context menu shouldn't cause WebView.navigationRequested to fire

  * Refresh gross-hack-for-dual-ffmpeg-build.patch
  * Fix LP: #1642317 - misaligned access when running mksnapshot during the
    armhf build. Add this as a distro-patch to avoid having to fork the v8
    repo for upstream checkouts. This isn't a problem for cross-builds anyway
    - Add debian/patches/lp1642317.patch
    - Update debian/patches/series
  * Add experimental Ubuntu UITK library and QML plugin packages. Note that
    this API is not stable yet and is likely to undergo breaking changes in
    future releases
    - update debian/control
    - update debian/rules
    - update debian/liboxideqt-qmlplugin.install
    - add debian/liboxideubuntuuitk0.install
    - add debian/qml-module-oxide-ubuntu.install


